// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from data_tamer_msgs:msg/Schema.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "data_tamer_msgs/msg/schema.hpp"


#ifndef DATA_TAMER_MSGS__MSG__DETAIL__SCHEMA__TRAITS_HPP_
#define DATA_TAMER_MSGS__MSG__DETAIL__SCHEMA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "data_tamer_msgs/msg/detail/schema__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace data_tamer_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Schema & msg,
  std::ostream & out)
{
  out << "{";
  // member: hash
  {
    out << "hash: ";
    rosidl_generator_traits::value_to_yaml(msg.hash, out);
    out << ", ";
  }

  // member: channel_name
  {
    out << "channel_name: ";
    rosidl_generator_traits::value_to_yaml(msg.channel_name, out);
    out << ", ";
  }

  // member: schema_text
  {
    out << "schema_text: ";
    rosidl_generator_traits::value_to_yaml(msg.schema_text, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Schema & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: hash
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hash: ";
    rosidl_generator_traits::value_to_yaml(msg.hash, out);
    out << "\n";
  }

  // member: channel_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "channel_name: ";
    rosidl_generator_traits::value_to_yaml(msg.channel_name, out);
    out << "\n";
  }

  // member: schema_text
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "schema_text: ";
    rosidl_generator_traits::value_to_yaml(msg.schema_text, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Schema & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace data_tamer_msgs

namespace rosidl_generator_traits
{

[[deprecated("use data_tamer_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const data_tamer_msgs::msg::Schema & msg,
  std::ostream & out, size_t indentation = 0)
{
  data_tamer_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use data_tamer_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const data_tamer_msgs::msg::Schema & msg)
{
  return data_tamer_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<data_tamer_msgs::msg::Schema>()
{
  return "data_tamer_msgs::msg::Schema";
}

template<>
inline const char * name<data_tamer_msgs::msg::Schema>()
{
  return "data_tamer_msgs/msg/Schema";
}

template<>
struct has_fixed_size<data_tamer_msgs::msg::Schema>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<data_tamer_msgs::msg::Schema>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<data_tamer_msgs::msg::Schema>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DATA_TAMER_MSGS__MSG__DETAIL__SCHEMA__TRAITS_HPP_
