// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from data_tamer_msgs:msg/Schema.idl
// generated code does not contain a copyright notice
#include "data_tamer_msgs/msg/detail/schema__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `channel_name`
// Member `schema_text`
#include "rosidl_runtime_c/string_functions.h"

bool
data_tamer_msgs__msg__Schema__init(data_tamer_msgs__msg__Schema * msg)
{
  if (!msg) {
    return false;
  }
  // hash
  // channel_name
  if (!rosidl_runtime_c__String__init(&msg->channel_name)) {
    data_tamer_msgs__msg__Schema__fini(msg);
    return false;
  }
  // schema_text
  if (!rosidl_runtime_c__String__init(&msg->schema_text)) {
    data_tamer_msgs__msg__Schema__fini(msg);
    return false;
  }
  return true;
}

void
data_tamer_msgs__msg__Schema__fini(data_tamer_msgs__msg__Schema * msg)
{
  if (!msg) {
    return;
  }
  // hash
  // channel_name
  rosidl_runtime_c__String__fini(&msg->channel_name);
  // schema_text
  rosidl_runtime_c__String__fini(&msg->schema_text);
}

bool
data_tamer_msgs__msg__Schema__are_equal(const data_tamer_msgs__msg__Schema * lhs, const data_tamer_msgs__msg__Schema * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // hash
  if (lhs->hash != rhs->hash) {
    return false;
  }
  // channel_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->channel_name), &(rhs->channel_name)))
  {
    return false;
  }
  // schema_text
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->schema_text), &(rhs->schema_text)))
  {
    return false;
  }
  return true;
}

bool
data_tamer_msgs__msg__Schema__copy(
  const data_tamer_msgs__msg__Schema * input,
  data_tamer_msgs__msg__Schema * output)
{
  if (!input || !output) {
    return false;
  }
  // hash
  output->hash = input->hash;
  // channel_name
  if (!rosidl_runtime_c__String__copy(
      &(input->channel_name), &(output->channel_name)))
  {
    return false;
  }
  // schema_text
  if (!rosidl_runtime_c__String__copy(
      &(input->schema_text), &(output->schema_text)))
  {
    return false;
  }
  return true;
}

data_tamer_msgs__msg__Schema *
data_tamer_msgs__msg__Schema__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  data_tamer_msgs__msg__Schema * msg = (data_tamer_msgs__msg__Schema *)allocator.allocate(sizeof(data_tamer_msgs__msg__Schema), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(data_tamer_msgs__msg__Schema));
  bool success = data_tamer_msgs__msg__Schema__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
data_tamer_msgs__msg__Schema__destroy(data_tamer_msgs__msg__Schema * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    data_tamer_msgs__msg__Schema__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
data_tamer_msgs__msg__Schema__Sequence__init(data_tamer_msgs__msg__Schema__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  data_tamer_msgs__msg__Schema * data = NULL;

  if (size) {
    data = (data_tamer_msgs__msg__Schema *)allocator.zero_allocate(size, sizeof(data_tamer_msgs__msg__Schema), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = data_tamer_msgs__msg__Schema__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        data_tamer_msgs__msg__Schema__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
data_tamer_msgs__msg__Schema__Sequence__fini(data_tamer_msgs__msg__Schema__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      data_tamer_msgs__msg__Schema__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

data_tamer_msgs__msg__Schema__Sequence *
data_tamer_msgs__msg__Schema__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  data_tamer_msgs__msg__Schema__Sequence * array = (data_tamer_msgs__msg__Schema__Sequence *)allocator.allocate(sizeof(data_tamer_msgs__msg__Schema__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = data_tamer_msgs__msg__Schema__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
data_tamer_msgs__msg__Schema__Sequence__destroy(data_tamer_msgs__msg__Schema__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    data_tamer_msgs__msg__Schema__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
data_tamer_msgs__msg__Schema__Sequence__are_equal(const data_tamer_msgs__msg__Schema__Sequence * lhs, const data_tamer_msgs__msg__Schema__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!data_tamer_msgs__msg__Schema__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
data_tamer_msgs__msg__Schema__Sequence__copy(
  const data_tamer_msgs__msg__Schema__Sequence * input,
  data_tamer_msgs__msg__Schema__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(data_tamer_msgs__msg__Schema);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    data_tamer_msgs__msg__Schema * data =
      (data_tamer_msgs__msg__Schema *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!data_tamer_msgs__msg__Schema__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          data_tamer_msgs__msg__Schema__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!data_tamer_msgs__msg__Schema__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
